
<template>
  <div id="Admin">
    <div id="top" class="panel">
      <LogOutBtn/>
      <h3>Admin page</h3>
    </div>

    <div id="main">
      <div id="users">
        <!-- new user modal -->
        <Modal v-if="addNewUser">
          <form @submit.prevent="addUser" id="newUser" class="panel">
            <h3>Add new {{ newUserRole }}</h3>
            <div>
              UserName: <input type="text" v-model="newUserName" autofocus />
            </div>
            <div id="btns">
              <button class="red" type="reset" @click="addNewUser = false">
                Cancel
              </button>
              <button class="green" type="submit">Add</button>
            </div>
          </form>
        </Modal>

        <!-- Admin user list -->
        <div class="userSection" id="adminSection">
          <List
            :gatherFunction="$services.backends.users.getAdminUsers"
            title="Admin"
            refreshEventName="refreshUsers"
          >
            <UserItem
              slot-scope="props"
              :user="props.item"
              v-on:delete="deleteUser"
            />
          </List>
        </div>

        <!-- Other user list -->
        <div class="userSection" id="userSection">
          <List
            :gatherFunction="$services.backends.users.getNonAdminUsers"
            title="Users"
            noItemMessage="No users"
            refreshEventName="refreshUsers"
            :newItemAction="addNonAdminUserBtn"
          >
            <UserItem
              slot-scope="props"
              :user="props.item"
              v-on:delete="deleteUser"
            />
          </List>
        </div>
      </div>

      <div id="maps">
        <List
          :gatherFunction="$services.backends.world.getMaps"
          title="Maps"
          noItemMessage="No maps"
          refreshEventName="refreshMaps"
          :newItemAction="
            () => {
              $router.push('/admin/maps/editor');
            }
          "
        >
          <MapItem
            slot-scope="props"
            :map="props.item"
            v-on:edit="editMap"
            v-on:delete="deleteMap"
          />
        </List>
      </div>
    </div>
    <ModalConfirm ref="confMod"/>
  </div>
</template>

<script lang="ts">
/**
 * @licence
 * Copyright 2022-2022 - RPG of the Apocalypse
 * Licensed under MIT or any later version
 * Refer to the LICENSE file included.
 */

import { Component, Vue } from "vue-property-decorator";
// Import components
import UserItem from "./users/User.vue";
import MapItem from "./maps/Map.vue";
import List from "../common/List.vue";
import Modal from "../common/Modal.vue";
import ModalConfirm from "../common/ModalConfirm.vue";
import LogOutBtn from "../common/LogOutBtn.vue";
// Import services
import { world, users } from "@/services/backends";

@Component({
  components: {
    UserItem,
    MapItem,
    List,
    Modal,
    ModalConfirm,
    LogOutBtn
  }
})
export default class AdminPage extends Vue {
  private addNewUser = false;
  private newUserName = "";
  private newUserRole: users.UserRole = users.UserRole.USER;

  $refs!: {
    confMod: ModalConfirm;
  };

  // Users
  addNonAdminUserBtn(): void {
    this.addNewUser = true;
    this.newUserRole = users.UserRole.USER;
  }

  async addUser(): Promise<void> {
    const userPassword: string = await users.addUser({
      username: this.newUserName,
      role: this.newUserRole
    });
    this.addNewUser = false;

    // Display the user password
    if (userPassword.length > 0) {
      await this.$refs.confMod.show({
        title: `The password for ${this.newUserName} is:`,
        message: userPassword,
        okButton: "Ok",
        cancelButton: ""
      });
    }

    this.newUserName = "";
    this.$emit("refreshUsers");
  }

  async deleteUser(username: string): Promise<void> {
    const ok = await this.$refs.confMod.show({
      title: "Remove user ?",
      message: "It cannot be undone.",
      okButton: "Remove"
    });

    if (ok) {
      await users.banUser(username);
      this.$emit("refreshUsers");
    }
  }

  // Maps
  editMap(mapId: string): void {
    this.$router.push("/admin/maps/editor/" + mapId);
  }

  async deleteMap(mapId: string): Promise<void> {
    const ok = await this.$refs.confMod.show({
      title: "Delete map ?",
      message: "It cannot be undone.",
      okButton: "Delete"
    });

    if (ok) {
      await world.deleteMap(mapId);
      this.$emit("refreshMaps");
    }
  }
}
</script>

<style scoped>
#Admin {
  height: 100%;
  display: flex;
  flex-direction: column;
}
#top {
  gap: 10px;
}
#main {
  flex: 1;
  display: flex;
}

/* Users */
#users {
  flex: 1;
  display: flex;
  flex-direction: column;
}
#users .userSection {
  flex: 1;
  padding-bottom: 30px;
}

/* New User */
#newUser {
  display: flex;
  flex-direction: column;
}
#newUser #btns {
  padding: 10px 5px 0 0;
  gap: 10px;
  display: flex;
  justify-content: flex-end;
}

/* Maps */
#maps {
  flex: 1;
  padding-bottom: 30px;
}
</style>
